# -*- coding: utf-8 -*-

#1a) La struttura secondaria di una sequenza di RNA, qualora gli appaiamenti 
# presenti siano annidati in modo appropriato, è rappresentabile con la 
# "dot-bracket notation", ovvero con una stringa lunga quanto la sequenza e in
# cui in ciascuna posizione compare il simbolo indicante l'appaiamento della 
# base alla stessa posizione: 
# "(" se essa è appaiata con una base a valle di essa, ")" se l'appaiamento è 
# con una base a monte, e "." in caso di nessun appaiamento. 
# Un modo alternativo per rappresentare la struttura secondaria, che chiamiamo
# "pairing indexes", sfrutta una lista di interi in cui in ciascuna posizione 
# si riporta l'indice della base appaiata (o l'indice della posizione stessa
# in caso di nessun appaiamento. 
#
# Es. "(.(.))" corrisponde a [5, 1, 4, 3, 2, 0]
#
# Si scriva una funzione bracket2indexes(bs) che, data una stringa bs che 
# contiene una rappresentazione con parentesi, restituisca una lista di interi 
# con i relativi "pairing indexes".
 

def bracket2indexes(bs):
    """
    Returns the list with the pairing indexes 
    corresponding to the "secondary structure" string bs
    """
    pairingStack = []
    res = [i for i in xrange(len(bs))]
    
    for i, b in enumerate(bs):
        if b == "(":
            pairingStack.append(i)
        elif b == ")":
            matching = pairingStack.pop()
            res[matching] = i
            res[i] = matching
            
    return res

