# -*- coding: utf-8 -*-

#3a) Si scriva una funzione (o meglio, predicato) feasible(s,p, wobble=False) 
# che, data una sequenza s di RNA e una stringa p con una possibile struttura 
# secondaria per essa, controlli se gli appaiamenti descritti in p possono 
# essere presenti in s. Il parametro facoltativo "wobble" specifica se si 
# debbano considerare oppure no gli accoppiamenti cosiddetti "wobble" (G-U).
#
# Es.: s="GGUCCACUUUAGCGAUUGCUC"
#      p="((.(.(((...).)..)).))"
#      feasible(s, p)         -> False
#      feasible(s, p, True)   -> True


def feasible(s,p, wobble=False):
    """
    Checks whether the RNA sequence s could be paired as indicated by p
    (no thermodynamic issue is considered).
    """
    if len(s) != len(p): return False
    
    def pairable(b1,b2):
        if b1 == b2: return False
        if (b1 in "AU" and b2 in "AU") or (b1 in "CG" and b2 in "CG"):
            return True
        if wobble and b1 in "GU" and b2 in "GU":
            return True
        return False
    
    tobepaired = []
    for base, par in zip(s,p):
        if par == "(":
            tobepaired.append(base)
        elif par == ")":
            matching = pairable(base,tobepaired.pop())
            if not matching: return False
    return True

