# -*- coding: utf-8 -*-

#4a) All'interno di una struttura secondaria di RNA, definiamo "elica" 
# una sequenza (MASSIMALE) di appaiamenti CONTIGUI, con lunghezza di almeno
# due appaiamenti. Per esempio, in una classica forcina, lo stelo (senza 
# alcuna base spaiata al suo interno) corrisponde a un'elica; sotto riportiamo 
# una rappresentazione a parentesi annotata con le eliche 1 e 2:
# .((.(((...))).))
# -22-111---111-22
# Si scriva una funzione countHelices(p, minlen=2) che calcoli il numero di 
# eliche lunghe almeno minlen all'interno della struttura codificata con 
# parentesi nella stringa p.
# Si assuma che la struttura in input corrisponda sempre a un corretto 
# annidamento degli appaiamenti.


def countHelices(p, minlen=2):
    """
    Returns the number of helixes in p having length >= minlen
    """

    pairingStack = [] #used to keep indexes of the first base of each pair
    totHelices = 0    #to count helixes
    curlen = 0        #length of the currently inspected helix
    prevmatching = -2 #index of the last upstream paired base
    
    for i,b in enumerate(p):
        if b == "(":
            pairingStack.append(i)
            if curlen >= minlen:
                totHelices += 1
            curlen = 0
        elif b == ")":
            matching = pairingStack.pop()
            if curlen == 0: #a new possible helix starts here
                curlen = 1
            #contiguity check: a possible helix is extending
            elif prevmatching - matching == 1: 
                curlen += 1
            #the possible prev helix may end, and a new one starts
            else: 
                if curlen >= minlen:
                    totHelices += 1              
                curlen = 1
            prevmatching = matching
        else: #case "."
            if curlen >= minlen:
                totHelices += 1
            curlen = 0
    
    if curlen >= minlen:
        totHelices += 1        
            
    return totHelices

