# -*- coding: utf-8 -*-

#3b) Con riferimento alla molocola di RNA descritta in 1et4.fasta, si 
# determinino quali strutture, tra quelle valide presenti in pairings.txt, 
# sono anche compatibili con essa in termini di possiblità di appaiamento tra 
# basi (considerando anche i wobble pairs). Le si scrivano su righe successive 
# del file uso3.txt con lo stesso ordine relativo con cui compaiono 
# in pairings.txt.


import Bio.SeqIO as SeqIO
from soluzione2 import validPairing as vp
from soluzione3 import feasible

infile1 = "1et4.fasta"
infile2 = "pairings.txt"
outfile = "uso3.txt"

rna = str(SeqIO.read(infile1, format="fasta").seq)

with open(infile2, "r") as fin:
    allPairings = [s.strip() for s in fin if s.strip()!=""]
   
with open(outfile, "w") as f:
    for p in filter(lambda p: feasible(rna, p, True), filter(vp, allPairings)):
        f.write(p+"\n")

